/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	esp8266.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-05-08
	*
	*	汾 		V1.0
	*
	*	˵ 		ESP8266ļ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭͷļ
//#include "stm32f10x.h"

//豸
#include "esp8266.h"

//Ӳ
//#include "delay.h"
//#include "usart.h"

#include "main.h"
#include "usart.h"


//C
#include <string.h>
#include <stdio.h>


#define ESP8266_WIFI_INFO		"AT+CWJAP=\"esp\",\"123456lljj\"\r\n"

#define ESP8266_ONENET_INFO		"AT+CIPSTART=\"TCP\",\"183.230.40.39\",6002\r\n"


unsigned char esp8266_buf[128];
unsigned short esp8266_cnt = 0, esp8266_cntPre = 0;

void Usart_SendString(UART_HandleTypeDef *huart, unsigned char *str, unsigned short len)
{

	unsigned short count = 0;
	
	HAL_UART_Transmit(huart,(uint8_t *)str,len,0xffff);
	while(HAL_UART_GetState(huart) == HAL_UART_STATE_BUSY_TX);

}

//==========================================================
//	ƣ	ESP8266_Clear
//
//	ܣ	ջ
//
//	ڲ	
//
//	ز	
//
//	˵		
//==========================================================
void ESP8266_Clear(void)
{

	memset(esp8266_buf, 0, sizeof(esp8266_buf));
	esp8266_cnt = 0;

}

//==========================================================
//	ƣ	ESP8266_WaitRecive
//
//	ܣ	ȴ
//
//	ڲ	
//
//	ز	REV_OK-		REV_WAIT-ճʱδ
//
//	˵		ѭüǷ
//==========================================================
_Bool ESP8266_WaitRecive(void)
{

	if(esp8266_cnt == 0) 							//ռΪ0 ˵ûдڽУֱ
		return REV_WAIT;
		
	if(esp8266_cnt == esp8266_cntPre)				//һεֵͬ˵
	{
		esp8266_cnt = 0;							//0ռ
			
		return REV_OK;								//ؽɱ־
	}
		
	esp8266_cntPre = esp8266_cnt;					//Ϊͬ
	
	return REV_WAIT;								//ؽδɱ־

}

//==========================================================
//	ƣ	ESP8266_SendCmd
//
//	ܣ	
//
//	ڲ	cmd
//				resҪķָ
//
//	ز	0-ɹ	1-ʧ
//
//	˵		
//==========================================================
_Bool ESP8266_SendCmd(char *cmd, char *res)
{
	
	unsigned char timeOut = 200;

	Usart_SendString(&huart3, (unsigned char *)cmd, strlen((const char *)cmd));
	
	while(timeOut--)
	{
		if(ESP8266_WaitRecive() == REV_OK)							//յ
		{
			if(strstr((const char *)esp8266_buf, res) != NULL)		//ؼ
			{
				ESP8266_Clear();									//ջ
				
				return 0;
			}
		}
		
		HAL_Delay(10);
	}
	
	return 1;

}

//==========================================================
//	ƣ	ESP8266_SendData
//
//	ܣ	
//
//	ڲ	data
//				len
//
//	ز	
//
//	˵		
//==========================================================
void ESP8266_SendData(unsigned char *data, unsigned short len)
{

	char cmdBuf[32];
	
	ESP8266_Clear();								//սջ
	sprintf(cmdBuf, "AT+CIPSEND=%d\r\n", len);		//
	if(!ESP8266_SendCmd(cmdBuf, ">"))				//յ>ʱԷ
	{
		Usart_SendString(&huart3, data, len);		//豸
	}

}

//==========================================================
//	ƣ	ESP8266_GetIPD
//
//	ܣ	ȡƽ̨ص
//
//	ڲ	ȴʱ(10ms)
//
//	ز	ƽ̨صԭʼ
//
//	˵		ͬ豸صĸʽͬҪȥ
//				ESP8266ķظʽΪ	"+IPD,x:yyy"	xݳȣyyy
//==========================================================
unsigned char *ESP8266_GetIPD(unsigned short timeOut)
{

	char *ptrIPD = NULL;
	
	do
	{
		if(ESP8266_WaitRecive() == REV_OK)								//
		{
			ptrIPD = strstr((char *)esp8266_buf, "IPD,");				//IPDͷ
			if(ptrIPD == NULL)											//ûҵIPDͷӳ٣Ҫȴһᣬᳬ趨ʱ
			{
				//printf("\"IPD\" not found\r\n");
			}
			else
			{
				ptrIPD = strchr(ptrIPD, ':');							//ҵ':'
				if(ptrIPD != NULL)
				{
					ptrIPD++;
					return (unsigned char *)(ptrIPD);
				}
				else
					return NULL;
				
			}
		}
		
		HAL_Delay(5);													//ʱȴ
	} while(timeOut--);
	
	return NULL;														//ʱδҵؿָ

}

//==========================================================
//	ƣ	ESP8266_Init
//
//	ܣ	ʼESP8266
//
//	ڲ	
//
//	ز	
//
//	˵		
//==========================================================
void ESP8266_Init(void)
{
	
//	GPIO_InitTypeDef GPIO_Initure;
//	
//	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);

//	//ESP8266λ
//	GPIO_Initure.GPIO_Mode = GPIO_Mode_Out_PP;
//	GPIO_Initure.GPIO_Pin = GPIO_Pin_5;					//GPIOB5-λ
//	GPIO_Initure.GPIO_Speed = GPIO_Speed_50MHz;
//	GPIO_Init(GPIOB, &GPIO_Initure);
//	
//	GPIO_WriteBit(GPIOB, GPIO_Pin_5, Bit_RESET);
//	HAL_Delay(250);
//	GPIO_WriteBit(GPIOB, GPIO_Pin_5, Bit_SET);
//	HAL_Delay(500);

//    HAL_GPIO_WritePin(ESP_RST_GPIO_Port,ESP_RST_Pin,GPIO_PIN_RESET);
//    HAL_Delay(250);
//    HAL_GPIO_WritePin(ESP_RST_GPIO_Port,ESP_RST_Pin,GPIO_PIN_SET);
//    HAL_Delay(500);
	
  ESP8266_Clear();
  
	printf("1. AT\r\n");
	while(ESP8266_SendCmd("AT\r\n", "OK"))
	HAL_Delay(1000);
	
	printf("2. CWMODE\r\n");
	while(ESP8266_SendCmd("AT+CWMODE=1\r\n", "OK"))
	HAL_Delay(1000);
	
	printf("3. CWJAP\r\n");
	while(ESP8266_SendCmd(ESP8266_WIFI_INFO, "GOT IP"))
	HAL_Delay(1000);
	
	printf("4. CIPSTART\r\n");
	while(ESP8266_SendCmd(ESP8266_ONENET_INFO, "CONNECT"))
	HAL_Delay(1000);
	
	printf("5. ESP8266 Init OK\r\n");

}




//==========================================================
//	ƣ	ESP8266_IRQHandler
//
//	ܣ	2շж
//
//	ڲ	
//
//	ز	
//

//	˵		
//==========================================================
//void ESP8266_IRQHandler(void)
//{
//		if(esp8266_cnt >= sizeof(esp8266_buf))
//    {            
//       esp8266_cnt = 0; //ֹڱˢ
//    }
//    esp8266_buf[esp8266_cnt++] = USART1->DR;
//}
